from CvPythonExtensions import *
import PyHelpers
import PushButtonUtils
import math
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer



class SpecialAttacks:
    
    def __init__(self):
        # I don't think these do anything anymore
        #self.iPushButton = -1
        #self.pPushedButtonUnit = -1 
        ## for some reason it rejects me assigning these in the init...?
        self.iExplosionFeature = -1
        self.iBigExplosionFeature = -1
        self.lHullDownFeatures = []
        self.lHullDownTerrains = []
        self.iExplosionResistPer10mm = 10
        self.ExplosiveDamageToArmorDivisor = 2
        ## so explosive damage is divided by 2 when it hits armor (usually still lethal)
        ## but can then be resisted by the ResistPer10mm for every 10mm of armor
        
        ## Camouflage Globals
        self.iMinSpottingDistance = 2 ## distance at which enemies WILL be detected
        self.iMaxSpottingDistance = 10 ## distance to test for detection
        self.lCamouflageFeatures = [gc.getInfoTypeForString("FEATURE_FOREST"),gc.getInfoTypeForString("FEATURE_JUNGLE")]
        self.lCamouflageBonuses = [-1, -2]
        self.iReCamoChance = 25 ## spotted units have a 25% chance of going back into camo each turn
        
        
    def loadSpecialUnitStats(self, xmlFile):
        self.iExplosionFeature = gc.getInfoTypeForString("FEATURE_CRATER_SMALL")
        self.iBigExplosionFeature = gc.getInfoTypeForString("FEATURE_CRATER_BIG")
        self.lHullDownTerrains.append(gc.getInfoTypeForString("TERRAIN_HILL"))
        self.lHullDownFeatures.append(gc.getInfoTypeForString("FEATURE_OASIS"))
        self.lHullDownFeatures.append(gc.getInfoTypeForString("FEATURE_CRATER_BIG"))      
        PushButtonUtils.lSpecialUnitStats = []
        i = 0
        for line in xmlFile.readlines():
            if "##" in line: continue
            if "<SpecialUnitStat>" in line:
                unitStat = SpecialUnitStat()
                unitStat.index = i
                i += 1
            elif "UnitType" in line:
                unitStat.UnitType = self.CutString(line)
            elif "iFrontArmor" in line:
                unitStat.iFrontArmor = int(self.CutString(line))
            elif "fFrontSlope" in line:
                unitStat.fFrontSlope = float(self.CutString(line))
            elif "iSidesArmor" in line:
                unitStat.iSidesArmor = int(self.CutString(line))
            elif "fSidesSlope" in line:
                unitStat.fSidesSlope = float(self.CutString(line))                
            elif "iRearArmor" in line:
                unitStat.iRearArmor = int(self.CutString(line))
            elif "fRearSlope" in line:
                unitStat.fRearSlope = float(self.CutString(line)) 
            elif "fHullDownCoefficient" in line:
                unitStat.fHullDownCoefficient = float(self.CutString(line))
            elif "fHullDownSlope" in line:
                unitStat.fHullDownSlope = float(self.CutString(line))
            elif "bDirectionalArmor" in line:
                unitStat.bDirectionalArmor = bool(eval(self.CutString(line)))
            elif "iRotateMoves" in line:
                unitStat.iRotateMoves = int(self.CutString(line))
            elif "iAccuracyBonus" in line:
                unitStat.iAccuracyBonus = int(self.CutString(line))
            elif "iCamouflage" in line:
                unitStat.iCamouflage = int(self.CutString(line))
            elif "iAntiCamo" in line:
                unitStat.iAntiCamo = int(self.CutString(line))
            elif "iFlatSpottedChance" in line:
                unitStat.iFlatSpottedChance = int(self.CutString(line))
            elif "iReduceEnemyAccuracy" in line:
                unitStat.iReduceEnemyAccuracy = int(self.CutString(line))
            elif "</SpecialUnitStat>" in line:
                PushButtonUtils.lSpecialUnitStats.append(unitStat)
    
    def canRotate(self, pUnit):
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            if pStat.iRotateMoves + pUnit.getMoves() <= (pUnit.baseMoves()*60):
                return pStat.bDirectionalArmor
            else:
                return False
        else:
            return False
        
    def doRotateClockwise(self, pUnit):
        pUnit.rotateFacingDirectionClockwise()
        pUnit.changeMoves(self.getSpecialUnitStats(pUnit).iRotateMoves)
    
    def doRotateCounterClockwise(self, pUnit):
        pUnit.rotateFacingDirectionCounterClockwise()
        pUnit.changeMoves(self.getSpecialUnitStats(pUnit).iRotateMoves)
        
    
    def loadAttacks(self, xmlFile):
        i = 0
        lineNum = 0
        PushButtonUtils.lAttacks = []
        for line in xmlFile.readlines():
            lineNum += 1
            if "##" in line: continue
            if "<SpecialAttackInfo>" in line:
                attack = SpecialAttack()
                attack.index = i
                i += 1
            elif "PromotionType" in line:
                attack.PromotionType = self.CutString(line)
            elif "Description" in line:
                attack.Description = self.CutString(line)
            elif "Strategy" in line:
                attack.Strategy = self.CutString(line)
            elif "<Effect>" in line:
                attack.Effect = self.CutString(line)
            elif "iRange" in line:
                attack.iRange = int(self.CutString(line))
            elif "iAccuracy" in line:
                attack.iAccuracy = int(self.CutString(line))
            elif "iAccDropoff" in line:
                attack.iAccDropoff = int(self.CutString(line))
            elif "iNumShots" in line:
                attack.iNumShots = int(self.CutString(line))
            elif "iVolleyAccDropoff" in line:
                attack.iVolleyDropoff = int(self.CutString(line))
            elif "iDamage" in line:
                attack.iDamage = int(self.CutString(line))
            elif "iDmgRand" in line:
                attack.iDmgRand = int(self.CutString(line))
            elif "iDmgLimit" in line:
                attack.iDmgLimit = int(self.CutString(line))
            elif "iPenetration" in line:
                attack.iPenetration = int(self.CutString(line))
            elif "iPenDropoff" in line:
                attack.iPenDropoff = int(self.CutString(line))
            elif "iPenRand" in line:
                attack.iPenRand = int(self.CutString(line))
            elif "bExplosive" in line:
                attack.bExplosive = bool(eval(self.CutString(line)))
            elif "bIndirectFire" in line:
                attack.bIndirectFire = bool(eval(self.CutString(line)))
            elif "bIgnoreDefenses" in line:
                attack.bIgnoreDefenses = bool(eval(self.CutString(line)))
            elif "bMissStillHits" in line:
                attack.bMissStillHits = bool(eval(self.CutString(line)))
            elif "iMaxMissRadius" in line:
                attack.iMaxMissRadius = int(self.CutString(line))
            elif "iMoves" in line:
                attack.iMoves = int(self.CutString(line))
            elif "bSpawnUnit" in line:
                attack.bSpawnUnit = bool(eval(self.CutString(line)))
            elif "SpawnUnitType" in line:
                attack.SpawnUnitType = self.CutString(line)
            elif "iSpawnUnitNum" in line:
                attack.iSpawnUnitNum = int(self.CutString(line))
            elif "bSpawnOnAttacker" in line:
                attack.bSpawnOnAttacker = bool(eval(self.CutString(line)))
            elif "bKillAttacker" in line:
                attack.bKillAttacker = bool(eval(self.CutString(line)))
            elif "bBarbarianOwner" in line:
                attack.bBarbarianOwner = bool(eval(self.CutString(line)))
            elif "iLoseCamo" in line:
                attack.iLoseCamo = int(self.CutString(line))
            elif "iAntiCamo" in line:
                attack.iAntiCamo = int(self.CutString(line))
            elif "bCheckSpotting" in line:
                attack.bCheckSpotting = bool(eval(self.CutString(line)))
            elif "bFaceTarget" in line:
                attack.bFaceTarget = bool(eval(self.CutString(line)))
            elif "isDefensiveEnemyNear" in line:
                attack.isDefensiveEnemyNear = bool(eval(self.CutString(line)))
            elif "isDefensiveEnemyFar" in line:
                attack.isDefensiveEnemyFar = bool(eval(self.CutString(line)))
            elif "iRemoveAttackChance" in line:
                attack.iRemoveAttackChance = int(eval(self.CutString(line)))
            elif "iReturnFireChance" in line:
                attack.iReturnFireChance = int(eval(self.CutString(line)))
            elif "iOpportunityFireChance" in line:
                attack.iOpportunityFireChance = int(eval(self.CutString(line)))
            elif "SetPromotion" in line:
                try:
                    gc.getInfoTypeForString(self.CutString(line))
                except:
                    CyInterface().addImmediateMessage("Wrong promotion tag in Special Attacks file, line %d" % lineNum,"")
                else:
                    attack.lSetPromotions.append(gc.getInfoTypeForString(self.CutString(line)))
            elif "iSetThatChance" in line:
                attack.lSetPromotionChances.append(int(self.CutString(line)))
            elif "bCanAttackSelf" in line:
                attack.bCanAttackSelf = bool(eval(self.CutString(line)))
            elif "SpawnUnitOnDeath" in line:
                attack.SpawnUnitOnDeath = self.CutString(line)
            elif "bDeathUnitBarbarian" in line:
                attack.bDeathUnitBarbarian = bool(eval(self.CutString(line)))
            elif "UnitClassTarget" in line:
                attack.UnitClassTarget = self.CutString(line)
            elif "UnitCombatTarget" in line:
                attack.UnitCombatTarget = self.CutString(line)
            elif "UnitTarget" in line:
                attack.UnitTarget = self.CutString(line)
            elif "CannotAttackUnitCombat" in line:
                try:
                    gc.getInfoTypeForString(self.CutString(line))
                except:
                    CyInterface().addImmediateMessage("Wrong unitcombat listed in Special Attacks file, line %d" % lineNum,"")
                else: 
                    attack.lCannotAttackUnitCombats.append(gc.getInfoTypeForString(self.CutString(line)))
            elif "</SpecialAttackInfo>" in line:
                PushButtonUtils.lAttacks.append(attack)
    
    def checkSpotting(self, pUnit, iReduceSelfCamo = 0, iReduceEnemyCamo = 0):
        ## ok here's how this works. 
        ## Some units have an invisible type, INVISIBLE_CAMOUFLAGE. 
        ## Whenever a unit moves, this method loops through all units within a certain range (global).
        ## If an enemy is a distance nearer than a unit's camouflage value,
        ## the camouflaged unit can be detected, at which point it losees its camouflage. 
        ## The chance increases up to a minimum 100% spotting distance. (global)
        ## An enemy's anticamo increases a unit's camo value so it can be spotted from further away.
        ## features can subtract from a unit's camo, so it can be invisible closer up.
        iThisPlayer = pUnit.getOwner()
        pThisPlayer = gc.getPlayer(iThisPlayer)
        iThisTeam = pThisPlayer.getTeam()
        for x in range(pUnit.getX() - self.iMaxSpottingDistance, pUnit.getX() + self.iMaxSpottingDistance):
            for y in range(pUnit.getY() - self.iMaxSpottingDistance, pUnit.getY() + self.iMaxSpottingDistance):
                if x < 0 or y < 0 or x > gc.getMap().getGridWidth() or y > gc.getMap().getGridHeight():
                    continue
                pPlot = gc.getMap().plot(x,y)
                if pPlot.getNumUnits() > 0:
                    for i in range(pPlot.getNumUnits()):
                        pTarget = pPlot.getUnit(i)
                        iTargetPlayer = pTarget.getOwner()
                        if iTargetPlayer == iThisPlayer:
                            ## spotting your own units makes no sense
                            continue
                        pTargetPlayer = gc.getPlayer(iTargetPlayer)
                        iTargetTeam = pTargetPlayer.getTeam()
                        if iTargetTeam == iThisTeam:
                            ## spotting team units makes no sense either
                            continue
                        #pTargetTeam = gc.getTeam(pTargetPlayer.getTeam())
                        #pThisTeam = gc.getTeam(pThisPlayer.getTeam())
                        #CyInterface().addImmediateMessage("count is %d" % pPlot.getInvisibleVisibilityCount(iTargetTeam, gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE")),"")                        
                        #if pPlot.getInvisibleVisibilityCount(iThisTeam, gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE")) > 0:
                        ## target unit's plot has invisible units on it
                        iEnemyCamouflage = self.iMaxSpottingDistance
                        iEnemyAntiCamo = 0
                        iEnemyFlatChance = 0
                        if self.isHasUnitStat(pTarget):
                            pStat = self.getSpecialUnitStats(pTarget)
                            iEnemyCamouflage = pStat.iCamouflage
                            iEnemyAntiCamo = pStat.iAntiCamo
                            if iEnemyCamouflage < 0:
                                iEnemyCamouflage = self.iMaxSpottingDistance
                            if iEnemyAntiCamo < 0:
                                iEnemyAntiCamo = 0
                            iEnemyFlatChance = pStat.iFlatSpottedChance
                        iEnemyCamouflage += iReduceEnemyCamo
                        iThisCamouflage = self.iMaxSpottingDistance
                        iThisAntiCamo = 0
                        iThisFlatChance = 0
                        if self.isHasUnitStat(pUnit):
                            pStat = self.getSpecialUnitStats(pUnit)
                            iThisCamouflage = pStat.iCamouflage
                            iThisAntiCamo = pStat.iAntiCamo
                            if iThisCamouflage < 0:
                                iThisCamouflage = self.iMaxSpottingDistance
                            if iThisAntiCamo < 0:
                                iThisAntiCamo = 0
                            iThisFlatChance = pStat.iFlatSpottedChance
                        iThisCamouflage += iReduceSelfCamo
                        if pPlot.getFeatureType() in self.lCamouflageFeatures:
                            windex = self.lCamouflageFeatures.index(pPlot.getFeatureType())
                            iCamoBonus = self.lCamouflageBonuses[windex]
                            iThisCamouflage += iCamoBonus
                        if pTarget.plot().getFeatureType() in self.lCamouflageFeatures:
                            windex = self.lCamouflageFeatures.index(pTarget.plot().getFeatureType())
                            iCamoBonus = self.lCamouflageBonuses[windex]
                            iEnemyCamouflage += iCamoBonus
                        if iThisCamouflage > self.iMaxSpottingDistance:
                            iThisCamouflage = self.iMaxSpottingDistance                            
                        fDistance = self.getDistance(pPlot, pUnit.plot())
                        iFlatRandTarget = CyGame().getSorenRandNum(100,"flat chance of spotting them")
                        iFlatRandThis = CyGame().getSorenRandNum(100,"flat chance of spotting us")
                        bTargetSeeOurPlot = pTarget.plot().canSeePlot(pPlot, iTargetTeam,int(fDistance),pTarget.getFacingDirection())
                        bWeSeeTargetPlot = pPlot.canSeePlot(pTarget.plot(), iThisTeam,int(fDistance),pUnit.getFacingDirection())
                        if (iFlatRandTarget < iEnemyFlatChance or iFlatRandThis < iThisFlatChance):
                            if (iFlatRandTarget < iEnemyFlatChance) and bWeSeeTargetPlot:
                                ## spotted the enemy
                                self.doSpotted(pPlot, iThisTeam, pTarget, pUnit)
                            if (iFlatRandThis < iThisFlatChance) and bTargetSeeOurPlot:
                                ## enemy spotted us
                                self.doSpotted(pPlot, iTargetTeam, pUnit, pTarget)
                            return
                        if fDistance < (iThisCamouflage + iEnemyAntiCamo) and bTargetSeeOurPlot:
                            ## Enemy can spot this unit
                            if self.checkSpotted(fDistance, iThisCamouflage + iEnemyAntiCamo):
                                ## Enemy spotted us
                                self.doSpotted(pPlot, iTargetTeam, pUnit, pTarget)
                        if fDistance < (iEnemyCamouflage + iThisAntiCamo) and bWeSeeTargetPlot:
                            ## We can spot enemy unit
                            if self.checkSpotted(fDistance, iEnemyCamouflage + iThisAntiCamo):
                                ## We spotted enemy
                                self.doSpotted(pPlot, iThisTeam, pTarget, pUnit)
                                
    def doSpotted(self, pTargetPlot, iSpottingTeam, pSpottedUnit, pSpotter):
        if pSpottedUnit.getInvisibleType() != -1:
            CyInterface().addMessage(pSpotter.getOwner(), False, 5, "Enemy %s spotted." % (pSpottedUnit.getName()),"",5,"",7,pSpottedUnit.getX(),pSpottedUnit.getY(),False,False)                                                
        pTargetPlot.changeInvisibleVisibilityCount(iSpottingTeam, gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE"),1)
        ## now we check for opportunity fire
        self.doTryReturnFire(pSpottedUnit, pSpotter.plot(), True)
                                    

    def checkSpotted(self, fDistance, iCamouflage):
        bSpotted = False
        fNumerator = float(iCamouflage) - fDistance
        fDenominator = float(iCamouflage) - float(self.iMinSpottingDistance)
        fPercentDist = fNumerator / fDenominator
        fSpotPi = fPercentDist * 0.5 * math.pi
        iSpotOdds = 100 * math.sin(fSpotPi) ** 10
        ## This is the chance that the unit will be spotted at this distance
        spotrand = CyGame().getSorenRandNum(100,"spot chance")
        if spotrand < iSpotOdds or fDistance < self.iMinSpottingDistance:
            ## enemy spotted us
            bSpotted = True
        return bSpotted                       
                        
    
    
    def doAttack(self, pAttacker, pPlot, pAttack):
        for i in range(pAttack.iNumShots):
            self.doAttackAt(pAttacker, pPlot, pAttack, i)
    
    def doAttackAt(self, pAttacker, pPlot, pAttack, iNumShot):
        pAttacker.changeMoves(pAttack.iMoves)
        ## do rotations
        if pAttack.bFaceTarget:
            self.doFaceTarget(pAttacker, pPlot)
        accuracy = self.getTrueAccuracy(pAttack, pAttacker, pPlot)
        accuracy -= pAttack.iVolleyDropoff * iNumShot
        ## add effects from volley accuracy
        accrand = CyGame().getSorenRandNum(100,"miss or not")
        if accrand > accuracy:## missed
            return self.doMissed(pAttacker, pAttack, accrand, accuracy, pPlot)
        pTarget = self.getTarget(pPlot, pAttacker, pAttack)
        if pTarget == -1:
            if pAttack.bMissStillHits and pAttack.bExplosive:
                self.doExplosiveDamage(pAttack.iDamage,pPlot,pAttacker)
            self.finishAttack(pAttacker, pPlot, pAttack)
            return
        elif pAttack.bExplosive:
            self.doExplosiveDamage(pAttack.iDamage, pPlot, pAttacker)
            self.finishAttack(pAttacker, pPlot, pAttack)
            return
        elif self.isHasUnitStat(pTarget):
            pStat = self.getSpecialUnitStats(pTarget)
            if pStat.iReduceEnemyAccuracy > 0:
                accuracy -= pStat.iReduceEnemyAccuracy
                if accrand > accuracy: ## turns out they actually did miss
                    return self.doMissed(pAttacker, pAttack, accrand, accuracy, pPlot)
        tArmorData = self.getArmorThickness(pAttacker, pTarget)
        iArmorThickness = tArmorData[0]
        sWhichPart = tArmorData[1]
        fImpactAngle = tArmorData[2]
        if iArmorThickness > 0 and not pAttack.bExplosive:
            pen = pAttack.iPenetration
            pen = self.getPenetration(pAttack, pAttacker, pTarget.plot())
            rando = CyGame().getSorenRandNum(2*pAttack.iPenRand,"randomness")
            rando -= pAttack.iPenRand
            pen += rando
            if pen <= iArmorThickness:
                CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s shot bounced off %s armor." % (pAttacker.getName(), pTarget.getName()),"",5,"",7,pTarget.getX(),pTarget.getY(),False,False)
                CyInterface().addMessage(pTarget.getOwner(), False, 5, "%s shot bounced off %s armor." % (pAttacker.getName(), pTarget.getName()),"",5,"",8,pTarget.getX(),pTarget.getY(),False,False)
                self.finishAttack(pAttacker, pPlot, pAttack)
                return
            ## Now check for ricochets real quick
            bRicochet = self.checkRicochet(pTarget, fImpactAngle, sWhichPart)
            if bRicochet:
                CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s shot ricocheted off %s armor." % (pAttacker.getName(), pTarget.getName()),"",5,"",7,pTarget.getX(),pTarget.getY(),False,False)
                CyInterface().addMessage(pTarget.getOwner(), False, 5, "%s shot ricocheted off %s armor." % (pAttacker.getName(), pTarget.getName()),"",5,"",8,pTarget.getX(),pTarget.getY(),False,False)
                self.finishAttack(pAttacker, pPlot, pAttack)
                return
        if not pAttack.bExplosive:
            self.doDamage(pAttack, pTarget, pAttacker)
        self.finishAttack(pAttacker, pPlot, pAttack)

    def doMissed(self, pAttacker, pAttack, accrand, accuracy, pPlot):
        CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s shot missed the target." % (pAttacker.getName()),"",5,"",7,pAttacker.getX(),pAttacker.getY(),False,False)
        if not pAttack.bMissStillHits:
            return
        else:
            iMissAccuracy = (100 - (accrand - accuracy)) / 2 
            ## To determine where the shot hits, I use a normal distribution around the target. 
            ## The MaxMissRadius is 3 standard deviations out from there. 
            zScores = [0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 2.0, 2.3, 3.0]
            zPercentiles = [0, 4, 8, 12, 16, 19, 23, 26, 29, 32, 34, 36, 38, 40, 42, 43, 45, 46, 47, 48, 49, 50]
            if len(zScores) != len(zPercentiles):
                CyInterface().addImmediateMessage("BUG: something wrong with this table","")
            iIndex = -1
            for iPercent in zPercentiles:
                if iMissAccuracy > iPercent:
                    continue
                else:
                    iIndex = zPercentiles.index(iPercent)
                    break
            if iIndex == -1:
                CyInterface().addImmediateMessage("BUG: something wrong with the index finding loop","")
            fDistance = zScores[iIndex]
            ## now divide the attack's MaxMissRadius by 3 to get one std dev distance
            fStdDevDist = float(pAttack.iMaxMissRadius) / 3.0
            ## multiply std dev dist by the zScore to get the actual distance missed
            fDistMiss = fStdDevDist * fDistance
            if fDistMiss < 1:
                fDistMiss = 1 ## can't hit the target - we already missed
            lPossibleHitTiles = []
            fClosestDist = 1000
            for xxx in range(pPlot.getX(), pPlot.getX() + pAttack.iMaxMissRadius):
                for yyy in range(pPlot.getY(), pPlot.getY() + pAttack.iMaxMissRadius):
                    testPlot = gc.getMap().plot(xxx, yyy)
                    dist = abs(self.getDistance(testPlot, pPlot) - fDistMiss)
                    if dist < fClosestDist:
                        ## This plot is closer to the optimal distance
                        fClosestDist = dist
                        lPossibleHitTiles = []
                        lPossibleHitTiles.append(testPlot)
                    elif dist == fClosestDist:
                        ## This plot is the same distance as other closest plots
                        lPossibleHitTiles.append(testPlot)
                    elif dist > fClosestDist:
                        ## This plot is not the optimal distance
                        continue
            if len(lPossibleHitTiles) == 0:
                CyInterface().addImmediateMessage("BUG: something went wrong finding a tile","")
                return
            
            randTile = CyGame().getSorenRandNum(len(lPossibleHitTiles),"yup")
            pNewPlot = lPossibleHitTiles[randTile]
            if pNewPlot == pPlot:
                CyInterface().addImmediateMessage("BUG: yeah this happened","")
            #newx = CyGame().getSorenRandNum(4,"randomness")
            #newy = CyGame().getSorenRandNum(4,"randomness")
            #pNewPlot = gc.getMap().plot(pPlot.getX() + newx, pPlot.getY() + newy)
            pNewTarget = self.getTarget(pNewPlot, pAttacker, pAttack)
            if pNewTarget == -1 and not pAttack.bExplosive:
                self.finishAttack(pAttacker, pPlot, pAttack)
                return
            elif pAttack.bExplosive:
                self.doExplosiveDamage(pAttack.iDamage, pNewPlot, pAttacker)
                self.finishAttack(pAttacker, pPlot, pAttack)
                return
            elif pNewTarget != -1:
                self.doDamage(pAttack, pNewTarget, pAttacker)
                self.finishAttack(pAttacker, pPlot, pAttack)
                return

    def getTrueAccuracy(self, pAttack, pAttacker, pPlot):
        accuracy = pAttack.iAccuracy
        accuracy = self.getAccuracy(pAttack, pAttacker, pPlot)
        if self.isHasUnitStat(pAttacker):
            pStat = self.getSpecialUnitStats(pAttacker)
            accuracy += pStat.iAccuracyBonus
        return accuracy

    def finishAttack(self, pAttacker, pPlot, pAttack):
        self.doSpawning(pAttack, pAttacker, pPlot)
        self.doSuicide(pAttack, pAttacker)
        self.doEffect(pAttack, pPlot)  
        if pAttack.bCheckSpotting:
            self.checkSpotting(pAttacker, pAttack.iLoseCamo, pAttack.iAntiCamo)
        self.doApplyPromotions(pAttacker, pPlot, pAttack)
        self.doTryRemoveAttack(pAttacker, pAttack)
        self.doTryReturnFire(pAttacker, pPlot)
        
    def doTryReturnFire(self, pAttacker, pReturnFirePlot, bOpportunityFire = False, iChance = 0):
        if pReturnFirePlot.getNumUnits() <= 0:
            return
        for i in range(pReturnFirePlot.getNumUnits()):            
            pFireUnit = pReturnFirePlot.getUnit(i)
            if not self.isHasAnyAttack(pFireUnit):
                continue
            if not (gc.getTeam(pFireUnit.getOwner()).isAtWar(gc.getPlayer(pAttacker.getOwner()).getTeam())):
                if not (pFireUnit.getOwner() == gc.getBARBARIAN_PLAYER() and pAttacker.getOwner() != gc.getBARBARIAN_PLAYER()):
                    if not (pAttacker.getOwner() == gc.getBARBARIAN_PLAYER() and pFireUnit.getOwner() != gc.getBARBARIAN_PLAYER()):
                        continue  
            ## unit is an enemy with an attack
            
            for pAttack in PushButtonUtils.lAttacks:
                iTestChance = iChance
                if iTestChance == 0 and bOpportunityFire:
                    iTestChance = pAttack.iOpportunityFireChance
                elif iTestChance == 0:
                    iTestChance = pAttack.iReturnFireChance
                if iTestChance > 0 and self.isHasAttack(pFireUnit, pAttack) and self.canAttackPlot(pFireUnit, pAttack, pAttacker.plot()):
                    attackrand = CyGame().getSorenRandNum(100, "chance enemy returns fire")
                    if attackrand <= iTestChance:
                        ## enemy returned fire
                        CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s attacked by opportunity fire." % (pAttacker.getName()),"",5,"",7,pAttacker.getX(),pAttacker.getY(),False,False)                            
                        self.doAttack(pFireUnit, pAttacker.plot(), pAttack)
            
        
    def doTryRemoveAttack(self, pAttacker, pAttack):
        if pAttack.iRemoveAttackChance <= 0:
            return
        removerand = CyGame().getSorenRandNum(100,"remove attack chance")
        if removerand < pAttack.iRemoveAttackChance:
            pAttacker.setHasPromotion(gc.getInfoTypeForString(pAttack.PromotionType), False)
        
    def doApplyPromotions(self, pAttacker, pApplyPlot, pAttack):
        if len(pAttack.lSetPromotions) <= 0:
            return
        windex = 0
        for iPromotion in pAttack.lSetPromotions:
            iSetChance = pAttack.lSetPromotionChances[windex]
            if pApplyPlot.getNumUnits() <= 0:
                return
            for i in range(pApplyPlot.getNumUnits()):
                ## applied regardless of nationality
                pUnit = pApplyPlot.getUnit(i)
                ## note that this chance is calculated for each unit individually
                setrand = CyGame().getSorenRandNum(100,"chance to set")
                if setrand <= iSetChance:
                    pUnit.setHasPromotion(iPromotion, True)
            windex += 1
                    
            
    
    def doEffect(self, pAttack, pPlot):
        if pAttack.Effect != "NONE":
            CyEngine().triggerEffect(gc.getInfoTypeForString(pAttack.Effect), pPlot.getPoint())

    def checkRicochet(self, pTarget, fImpactAngle, sWhichPart):
        ## bullet has two chances of ricocheting
        ## first, for sloped armor
        fArmorSlopeAngle = 0.0
        if self.isHasUnitStat(pTarget):
            pStat = self.getSpecialUnitStats(pTarget)
            if self.isHullDown(pTarget):
                fArmorSlopeAngle = pStat.fHullDownSlope
            elif sWhichPart == "Front":
                fArmorSlopeAngle = pStat.fFrontSlope
            elif sWhichPart == "Sides":
                fArmorSlopeAngle = pStat.fSidesSlope
            else:
                fArmorSlopeAngle = pStat.fRearSlope
        fFirstChance = math.sin(fArmorSlopeAngle) ** 4
        fFirstChance *= 100       
        rand = CyGame().getSorenRandNum(100, "ricochet off sloped armor chance")
        if rand <= fFirstChance:
            ## bullet ricochets
            return True
        ## second, for impact angle
        fSecondChance = math.sin(fImpactAngle) ** 4
        fSecondChance *= 100
        rand = CyGame().getSorenRandNum(100, "ricochet because of shot angle chance")
        if rand <= fSecondChance:
            ## bullet ricochets
            return True
        return False
                
        
    
    
    def doSuicide(self, pAttack, pAttacker):
        if pAttack.bKillAttacker:
            iPlayer = pAttacker.getOwner()
            pAttacker.kill(False, iPlayer)

    def doSpawning(self, pAttack, pAttacker, pPlot):
        if pAttack.bSpawnUnit:
            pPlayer = -1
            if pAttack.bBarbarianOwner:
                pPlayer = gc.getPlayer(gc.getBARBARIAN_PLAYER())
            else:
                pPlayer = gc.getPlayer(pAttacker.getOwner())
            iSpawnX = -1
            iSpawnY = -1
            if pAttack.bSpawnOnAttacker:
                iSpawnX = pAttacker.getX()
                iSpawnY = pAttacker.getY()
            else:
                iSpawnX = pPlot.getX()
                iSpawnY = pPlot.getY()
            for i in range(pAttack.iSpawnUnitNum):
                pPlayer.initUnit(gc.getInfoTypeForString(pAttack.SpawnUnitType),iSpawnX,iSpawnY,UnitAITypes.NO_UNITAI,DirectionTypes.NO_DIRECTION)
        
        
    def doExplosiveDamage(self, iDmg, pPlot, pAttacker):
        if pPlot.isWater():
            CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s shot hit the water." % (pAttacker.getName()),"",5,"",7,pPlot.getX(),pPlot.getY(),False,False)    
            return
        dd = iDmg
        i = 0
        if iDmg > 1000:
            pPlot.setFeatureType(self.iBigExplosionFeature, -1)
        else:
            pPlot.setFeatureType(self.iExplosionFeature, -1)
        ## do damage to unit on the target plot
        #if pPlot.getNumUnits() > 0:
            #for k in range(pPlot.getNumUnits()):
                #pExplodeUnit = pPlot.getUnit(k)
                #self.doExplosiveDamageUnit(pAttacker, pExplodeUnit, dd, pPlot)
        while dd > 1:
            for xx in range(pPlot.getX() - i, pPlot.getX() + i + 1):
                for yy in range(pPlot.getY() - i, pPlot.getY() + i + 1):
                    #if abs(pPlot.getX() - xx) < i and abs(pPlot.getY() - yy) < i: ## This means we have gone through the tile already
                        #continue
                    #else:
                    pExplodePlot = gc.getMap().plot(xx,yy)
                    if pExplodePlot.getNumUnits() > 0:
                        for k in range(pExplodePlot.getNumUnits()):
                            pExplodeUnit = pExplodePlot.getUnit(k)
                            self.doExplosiveDamageUnit(pAttacker, pExplodeUnit, dd, pPlot) 
            dd = iDmg / ((i+2)**2)
            i += 1

    def doExplosiveDamageUnit(self, pAttacker, pExplodeUnit, dd, pPlot):
        fModifiedDamage = self.getModifiedExplosiveDamage(dd, pExplodeUnit, pAttacker)
        iModifiedDamage = int(fModifiedDamage)
        if iModifiedDamage <= 0:
            return
        pExplodeUnit.changeDamage(iModifiedDamage, pExplodeUnit.getOwner())
        CyInterface().addMessage(pExplodeUnit.getOwner(), False, 5, "%s hit by %d explosive damage" % (pExplodeUnit.getName(), fModifiedDamage),"",5,"",7,pPlot.getX(),pPlot.getY(),False,False)
                    

    def getModifiedExplosiveDamage(self, dd, pExplodeUnit, pAttacker):
        fModifiedDamage = float(dd)
        fModifiedDamage /= self.ExplosiveDamageToArmorDivisor
        iArmor = self.getArmorThickness(pAttacker, pExplodeUnit)[0] ## don't care about angle here
        fModifiedDamage = fModifiedDamage - (float(iArmor / 10)*self.iExplosionResistPer10mm)
        return fModifiedDamage

    def doDamage(self, pAttack, pTarget, pAttacker):
        iDmg = pAttack.iDamage
        rand = CyGame().getSorenRandNum(2*pAttack.iDmgRand,"randomness")
        rand -= pAttack.iDmgRand
        iDmg += rand
        if not pAttack.bIgnoreDefenses:
            targetstr = float(pTarget.baseCombatStr())
            targetmodstr = pTarget.currCombatStrFloat(pTarget.plot(),pAttacker)
            dmgmod = float(iDmg)*(targetstr/targetmodstr)
            iDmg = int(dmgmod)
        if iDmg + pTarget.getDamage() > pAttack.iDmgLimit:
            iDmg = pAttack.iDmgLimit - pTarget.getDamage()
        pTarget.changeDamage(iDmg, pTarget.getOwner())
        CyInterface().addMessage(pAttacker.getOwner(), False, 5, "%s attacked %s for %d damage!" % (pAttacker.getName(), pTarget.getName(), iDmg),"",5,"",8,pTarget.getX(),pTarget.getY(),False,False)
        CyInterface().addMessage(pTarget.getOwner(), False, 5, "%s attacked %s for %d damage!" % (pAttacker.getName(), pTarget.getName(), iDmg),"",5,"",7,pTarget.getX(),pTarget.getY(),False,False)
        
                    

    def getTarget(self, pPlot, pAttacker, pAttack):
        lPotentialTargets = []
        pTarget = -1
        for h in range(pPlot.getNumUnits()):
            pPotentialTarget = pPlot.getUnit(h)
            if pPotentialTarget.getUnitCombatType() in pAttack.lCannotAttackUnitCombats:
                ## can't attack this target, so won't select it as a target
                continue
            if gc.getTeam(pPotentialTarget.getOwner()).isAtWar(gc.getPlayer(pAttacker.getOwner()).getTeam()):
                lPotentialTargets.append(pPotentialTarget)
            elif pPotentialTarget.getOwner() == gc.getBARBARIAN_PLAYER() and pAttacker.getOwner() != gc.getBARBARIAN_PLAYER():
                lPotentialTargets.append(pPotentialTarget)
            elif pAttacker.getOwner() == gc.getBARBARIAN_PLAYER() and pPotentialTarget.getOwner() != gc.getBARBARIAN_PLAYER():
                lPotentialTargets.append(pPotentialTarget)
            if pAttack.UnitTarget != "NONE" and len(lPotentialTargets) > 0:
                lUnitTargets = []
                lUnitClassTargets = []
                lUnitCombatTargets = []
                for pUnit in lPotentialTargets:
                    if pUnit.getUnitType() == gc.getInfoTypeForString(pAttack.UnitTarget):
                        lUnitTargets.append(pUnit)
                    if pUnit.getUnitClassType() == gc.getInfoTypeForString(pAttack.UnitClassTarget):
                        lUnitClassTargets.append(pUnit)
                    if pUnit.getUnitCombatType() == gc.getInfoTypeForString(pAttack.UnitCombatTarget):
                        lUnitCombatTargets.append(pUnit)
                if len(lUnitTargets) > 0:
                    ## going to select a unit target
                    pTarget = self.getGreatestStrengthUnit(lUnitTargets, pAttacker)
                elif len(lUnitClassTargets) > 0:
                    pTarget = self.getGreatestStrengthUnit(lUnitClassTargets, pAttacker)
                elif len(lUnitCombatTargets) > 0:
                    pTarget = self.getGreatestStrengthUnit(lUnitCombatTargets, pAttacker)
                else:
                    pTarget = self.getGreatestStrengthUnit(lPotentialTargets, pAttacker)
        return pTarget
    
    def getGreatestStrengthUnit(self, listylist, pAttacker):
        iStrength = 0
        pUnit = -1
        for unit in listylist:
            if unit.currCombatStr(unit.plot(), pAttacker) > iStrength:
                iStrength = unit.currCombatStr(unit.plot(), pAttacker)
                pUnit = unit
        return pUnit
    
    def isHasAnyAttack(self, pUnit):
        for pAttack in PushButtonUtils.lAttacks:
            if pUnit.isHasPromotion(gc.getInfoTypeForString(pAttack.PromotionType)):
                return True
        return False  
    
    def canUseAttack(self, pUnit, pAttack):
        if pUnit.getMoves() + pAttack.iMoves <= (pUnit.baseMoves()*60):
            return True
        else:
            return False
        
    def getAttack(self, iDataVal):
        iIndex = iDataVal - 301
        if not (iIndex > len(PushButtonUtils.lAttacks)):
            pAttack = PushButtonUtils.lAttacks[iIndex]
            return pAttack
        return -1
    
    def canAttackPlot(self, pAttacker, pAttack, pTargetPlot):
        if pTargetPlot.getX() == pAttacker.getX() and pTargetPlot.getY() == pAttacker.getY() and pAttack.bCanAttackSelf:
            return True
        if not self.canUseAttack(pAttacker, pAttack):
            return False
        if not pTargetPlot.isUnit():
            if not pAttack.bExplosive:
                return False
        if not pAttack.bMissStillHits:
            if self.getTarget(pTargetPlot, pAttacker, pAttack) == -1:
                return False
        if not pTargetPlot.isVisibleEnemyDefender(pAttacker):
            if not pAttack.bMissStillHits:
                return False
        if pTargetPlot == pAttacker.plot() and not pAttack.bCanAttackSelf:
            return False
        if self.getDistance(pAttacker.plot(), pTargetPlot) > pAttack.iRange:
            return False
        if not pAttack.bIndirectFire:
            if not pAttacker.plot().canSeePlot(pTargetPlot, gc.getPlayer(pAttacker.getOwner()).getTeam(),pAttack.iRange,-1):
                return False
        return True
    
    def getDistance(self, plot1, plot2):
        x1 = plot1.getX()
        x2 = plot2.getX()
        y1 = plot1.getY()
        y2 = plot2.getY()
        dist1 = float((x1-x2)**2)
        dist2 = float((y1-y2)**2)
        dist = (dist1+dist2)**0.5
        return float(dist)
    
    def getPenetration(self, pAttack, pAttacker, pPlot):
        dist = self.getDistance(pAttacker.plot(), pPlot)
        drop = pAttack.iPenDropoff
        pen = pAttack.iPenetration - (drop * dist)
        return pen
    
    def getPenetrationDist(self, pAttack, iDistance):
        drop = pAttack.iPenDropoff
        pen = pAttack.iPenetration - (drop * iDistance)
        return pen
    
    def getAccuracy(self, pAttack, pAttacker, pPlot):
        dist = self.getDistance(pAttacker.plot(), pPlot)
        drop = pAttack.iAccDropoff
        acc = pAttack.iAccuracy - (drop * dist)
        return acc
    
    def getAccuracyDist(self, pAttack, iDistance):
        drop = pAttack.iAccDropoff
        acc = pAttack.iAccuracy - (drop * iDistance)
        return acc
    
    def getArmorThickness(self, pAttacker, pUnit):
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            bCanHitSides = True ## if the vehicle is facing us we can't hit its side
            ## aiming at front or rear?
            sWhich = "Front"
            iAttackX = pAttacker.getX()
            iAttackY = pAttacker.getY()
            iTargetX = pUnit.getX()
            iTargetY = pUnit.getY()
            iTargetDir = pUnit.getFacingDirection()
            if iAttackX < iTargetX and iAttackY < iTargetY:
                ## target is to the northeast
                if iTargetDir >= 0 and iTargetDir <= 2:
                    sWhich = "Rear"
            elif iAttackX < iTargetX and iAttackY > iTargetY:
                ## target is to the southeast
                if iTargetDir >= 2 and iTargetDir <= 4:
                    sWhich = "Rear"
            elif iAttackX > iTargetX and iAttackY < iTargetY:
                ## target is to the northwest
                if iTargetDir == 6 or iTargetDir == 7 or iTargetDir == 0:
                    sWhich = "Rear"
            elif iAttackX > iTargetX and iAttackY > iTargetY:
                ## target is to the southwest
                if iTargetDir >= 4 and iTargetDir <= 6:
                    sWhich = "Rear"
            elif iAttackX == iTargetX:
                if iAttackY > iTargetY and iTargetDir == 4:
                    ## target is to the south, facing south
                    sWhich = "Rear"
                elif iAttackY < iTargetY and iTargetDir == 0:
                    ## target is to the north, facing north
                    sWhich = "Rear"
            elif iAttackY == iTargetY:
                if iAttackX < iTargetX and iTargetDir == 2:
                    ## target is to the east, facing east
                    sWhich = "Rear"
                elif iAttackX > iTargetX and iTargetDir == 6:
                    ## target is to the west, facing west
                    sWhich = "Rear"      
            ## check front
            iBaseFrontArmor = self.getFrontArmor(pUnit)
            if sWhich == "Rear":
                iBaseFrontArmor = self.getRearArmor(pUnit)
            fFrontImpactAngle = self.getImpactAngle(pAttacker, pUnit)
            fFrontArmorThickness = self.getTrueArmor(fFrontImpactAngle, iBaseFrontArmor)
            ## check sides
            iBaseSideArmor = self.getSideArmor(pUnit)
            fSideImpactAngle = self.getImpactAngle(pAttacker, pUnit, True)
            if fSideImpactAngle > 1.39 and fSideImpactAngle < 1.75:
                ## angle is within 10 degrees of being 90 degrees from norm of tank armor
                ## in other words, it's almost lined up with the armor
                bCanHitSides = False
                ## way too steep an angle to hit the side of the tank. 
            if self.isHullDown(pUnit):
                ## if hull down then the turret faces us, so can't hit sides
                bCanHitSides = False
                ## vehicles without turrets don't have a hull down bonus. 
            fSideArmorThickness = self.getTrueArmor(fSideImpactAngle, iBaseSideArmor)
            if fFrontArmorThickness < fSideArmorThickness or bCanHitSides == False:
                ## shots always target the weakest spots
                return (fFrontArmorThickness, sWhich, fFrontImpactAngle)
            else:
                return (fSideArmorThickness, "Sides", fSideImpactAngle)
        ## target has no armor
        return (0, "None", 0)
    
    def doFaceTarget(self, pAttacker, pTargetPlot):
        iFaceDirection = self.getDirectionToTarget(pAttacker.getX(), pAttacker.getY(), pTargetPlot) + 4
        if iFaceDirection > 7:
            iFaceDirection -= 8
        while pAttacker.getFacingDirection() != iFaceDirection:
            pAttacker.rotateFacingDirectionClockwise()
        
    
    def isHullDown(self, pUnit):
        if pUnit.plot().getTerrainType() in self.lHullDownTerrains or pUnit.plot().getFeatureType() in self.lHullDownFeatures or pUnit.plot().isHills():
            return True
        return False 
        
    def getSideArmor(self, pUnit):
        fArmor = 0.0
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            fArmor = pStat.iSidesArmor
            if pStat.fSidesSlope > 0.0:
                fArmor = self.getTrueArmor(pStat.fSidesSlope, fArmor)
        return fArmor
    
    def getFrontArmor(self, pUnit):
        fArmor = 0.0
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            fArmor = pStat.iFrontArmor
            if self.isHullDown(pUnit):
                fArmor = pStat.iFrontArmor * pStat.fHullDownCoefficient
                fArmor = self.getTrueArmor(pStat.fHullDownSlope, fArmor)
            elif pStat.fFrontSlope > 0.0:
                fArmor = self.getTrueArmor(pStat.fFrontSlope, fArmor)
        return fArmor
    
    def getRearArmor(self, pUnit):
        fArmor = 0.0
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            fArmor = pStat.iRearArmor
            if pStat.fRearSlope > 0.0:
                fArmor = self.getTrueArmor(pStat.fRearSlope, fArmor)
        return fArmor    
                
        
        
    def getTrueArmor(self, fAngle, fArmor):
        thickness = float(fArmor) / float(math.cos(fAngle))
        return thickness
    
    def getSlopeSideArmor(self, pUnit):
        ## returns the slope of the line normal to the side armor
        fSlope = 0.0
        dr = pUnit.getFacingDirection()
        if dr == 0 or dr == 4:
            fSlope = 0.0
        elif dr == 1 or dr == 5:
            fSlope = -1.0
        elif dr == 2 or dr == 6:
            fSlope = 10000.0
        elif dr == 3 or dr == 7:
            fSlope = 1.0
        return fSlope
    
    def getSlopeFrontArmor(self, pUnit):
        ## returns the slope of the line normal to the front/rear armor
        fSlope = 0.0
        dr = pUnit.getFacingDirection()
        if dr == 0 or dr == 4:
            fSlope = 10000.0
        elif dr == 1 or dr == 5:
            fSlope = 1.0
        elif dr == 2 or dr == 6:
            fSlope = 0.0
        elif dr == 3 or dr == 7:
            fSlope = -1.0
        return fSlope
    
    def getSlopeToTarget(self, pAttacker, pTarget):
        ## returns the slope of a line dfrom attacker to target
        dy = pTarget.getY() - pAttacker.getY()
        dx = pTarget.getX() - pAttacker.getX()
        if dx == 0:
            return 10000.0
        fSlope = float(dy) / float(dx)
        return fSlope
    
    def getImpactAngle(self, pAttacker, pTarget, bSides = False):
        slopeEnemy = 0.0
        if self.isHullDown(pTarget):
            bSides = False
            ## shots to the hull-down turret always hit the front of the turret.
        if bSides:
            slopeEnemy = self.getSlopeSideArmor(pTarget)
        else:
            slopeEnemy = self.getSlopeFrontArmor(pTarget)
        slopeAttacker = self.getSlopeToTarget(pAttacker, pTarget)
        slopediff = float(slopeEnemy - slopeAttacker)
        slopemult = float(slopeEnemy * slopeAttacker)
        if (1+ slopemult) == 0:
            return 3.14 ## 90 degrees
        angle = abs(math.atan(slopediff / (1 + slopemult)))
        return angle ## This will be in radians
        
        
        
        
    
    def isHasAttack(self, pUnit, pAttack):
        if pUnit.isHasPromotion(gc.getInfoTypeForString(pAttack.PromotionType)):
            return True
        else:
            return False
    
    def getHelpText(self, pAttack):
        if pAttack == -1:
            return ""
        newString = pAttack.Description
        newString += "\nAvg Dmg: " 
        newString += str(pAttack.iDamage)
        newString += "\nRange: "
        newString += str(pAttack.iRange)
        newString += "\nAvg Accuracy: "
        newString += str(self.getAccuracyDist(pAttack, pAttack.iRange / 2))
        newString += "%"
        newString += "\nMoves: "
        newString += str(float(pAttack.iMoves/60))
        if pAttack.iPenetration > 0:
            newString += "\nAvg Penetration: "
            newString += str(self.getPenetrationDist(pAttack, pAttack.iRange / 2))
            newString += " mm"
        newString += "\n"
        newString += str(pAttack.iNumShots)
        if pAttack.iNumShots > 1:
            newString += "-shot volley ("
            newString += str(pAttack.iVolleyDropoff)
            newString += "% drop) "
        else:
            newString += " shot "
        if pAttack.bExplosive:
            newString += "- Explosive "
        if pAttack.bIndirectFire:
            newString += "- Indirect Fire "
        if pAttack.bIgnoreDefenses:
            newString += "- Ignore Defenses "
        if pAttack.bMissStillHits:
            newString += "- Shot Spread "
            newString += str(pAttack.iMaxMissRadius)
        if pAttack.iRemoveAttackChance > 0:
            newString += "\n"
            newString += str(pAttack.iRemoveAttackChance)
            newString += "% chance of removal on use"
        if not pAttack.lCannotAttackUnitCombats:
            Donothing = True
            ## yes this is an ugly way to do this but it works
        else:
            newString += "\n"
            newString += "Cannot attack "
            r = 0
            for unitcombat in pAttack.lCannotAttackUnitCombats:
                UnitCombatInfo = gc.getUnitCombatInfo(unitcombat)
                newString += UnitCombatInfo.getDescription()
                if (r + 1) < len(pAttack.lCannotAttackUnitCombats):
                    newString += ", "
                r += 1
        if not pAttack.lSetPromotions:
            Donothing = True
        else:
            newString += "\n"
            newString += "Chance to apply "
            r = 0
            for promotion in pAttack.lSetPromotions:
                PromotionInfo = gc.getPromotionInfo(promotion)
                newString += PromotionInfo.getDescription()
                newString += " ("
                newString += str(pAttack.lSetPromotionChances[r])
                newString += "%)"
                if (r + 1) < len(pAttack.lSetPromotions):
                    newString += ", "
                r += 1
        
                
        if pAttack.bSpawnUnit:
            newString += "\n"
            newString += "Spawns "
            newString += str(pAttack.iSpawnUnitNum)
            if pAttack.bBarbarianOwner:
                newString += " Barbarian"
            newString += " units on "
            if pAttack.bSpawnOnAttacker:
                newString += "attacker."
            else:
                newString += "target."
        if pAttack.bKillAttacker:
            newString += "\n"
            newString += "Dies on attack."
        if pAttack.bCheckSpotting:
            newString += "\n"
            newString += "May reveal self/enemies on attack."
        if pAttack.bFaceTarget:
            newString += "\n"
            newString += "Will turn to face target."
        
        newString += "\n"
        newString += "\n"
        newString += pAttack.Strategy        
        return newString
        
    
    def doResetCamo(self, iPlayer):
        pyPlayer = PyPlayer(iPlayer)
        unitList = pyPlayer.getUnitList()
        for pUnit in unitList:
            UnitInfo = gc.getUnitInfo(pUnit.getUnitType())
            if UnitInfo.getInvisibleType() == gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE"):
                if pUnit.getInvisibleType() != gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE"):
                    recamorand = CyGame().getSorenRandNum(100,"chance to invisiblify")
                    if recamorand < self.iReCamoChance:
                        pUnit.plot().changeInvisibleVisibilityCount(gc.getTeam(iPlayer),gc.getInfoTypeForString("INVISIBLE_CAMOUFLAGE"),-1)
    
    
    ## This method handles the AI for the attacks
    def doAttacksAI(self, iPlayer):
        pyPlayer = PyPlayer(iPlayer)
        unitList = pyPlayer.getUnitList()
        for pUnit in unitList:
            if not self.isHasAnyAttack(pUnit): continue
            lEffectiveAttacks = []
            for pAttack in PushButtonUtils.lAttacks:
                if self.isHasAttack(pUnit, pAttack):
                    lEnemies = self.getEnemies(pUnit, pAttack.iRange)
                    for pEnemy in lEnemies:
                        if self.isEffectiveAttack(pUnit, pAttack, pEnemy):
                            attack = [pAttack, pEnemy]
                            lEffectiveAttacks.append(attack)
            if len(lEffectiveAttacks) > 0:
                iGreatestDamage = 0
                iIndex = -1
                for i in range(len(lEffectiveAttacks)):
                    if lEffectiveAttacks[i][0].iDamage > iGreatestDamage:
                        iGreatestDamage = lEffectiveAttacks[i][0].iDamage
                        iIndex = i
                iWhichAttack = iIndex
                self.doAttack(pUnit, lEffectiveAttacks[iWhichAttack][1].plot(), lEffectiveAttacks[iWhichAttack][0])
                            
    def doEndTurnMovesAI(self, iPlayer):
        pyPlayer = PyPlayer(iPlayer)
        unitList = pyPlayer.getUnitList()
        for pUnit in unitList:
            lEnemies = self.getDangerousEnemies(pUnit)
            ## returns list of enemies that can penetrate our weak spots
            ## this is a list with three columns - pEnemy, iDamage, iDirection
            ## now the task is to assess where the most damage comes from
            if len(lEnemies) == 0:
                continue ## unit has no enemies, lucky fella
            iMostPotentialDamage = 0
            iDamagingDirection = 0
            for D in range(8): ## all 8 directions
                iPotentialDamage = 0
                for i in range(len(lEnemies)):
                    if lEnemies[i][2] == D:
                        iPotentialDamage += lEnemies[i][1]
                if iPotentialDamage > iMostPotentialDamage:
                    iDamagingDirection = D
                    iMostPotentialDamage = iPotentialDamage
            ## now we know what direction is most dangerous; time to turn the tank that way
            sStrongestArmor = self.getStrongestArmorPart(pUnit)
            if sStrongestArmor == "Front":
                ## turn directly toward the biggest damage
                while pUnit.getFacingDirection() != iDamagingDirection:
                    pUnit.rotateFacingDirectionClockwise()
            elif sStrongestArmor == "Sides":
                ## turn 90 degrees to the target
                while pUnit.getFacingDirection() != self.getSidesDirection(iDamagingDirection):
                    pUnit.rotateFacingDirectionClockwise()                 
            elif sStrongestArmor == "Rear":
                ## turn 180 degrees to the target
                ## probably no tanks would actually do this but it is an option
                while pUnit.getFacingDirection() != self.getRearDirection(iDamagingDirection):
                    pUnit.rotateFacingDirectionClockwise()
            
            
            ## AI Defensive Attacks - these will be done on the AI unit itself.
            if self.isHasAnyAttack(pUnit):
                for pAttack in PushButtonUtils.lAttacks:
                    if pAttack.isDefensiveEnemyNear or pAttack.isDefensiveEnemyFar:
                        bEnemyNear = False
                        ## if enemy is within the maximum spotting distance, do this attack
                        ## we will allow the AI to do this regardless of whether or not enemies are spotted
                        for x in range(pUnit.getX() - self.iMaxSpottingDistance, pUnit.getX() + self.iMaxSpottingDistance):
                            for y in range(pUnit.getY() - self.iMaxSpottingDistance, pUnit.getY() + self.iMaxSpottingDistance):
                                if x < 0 or x > gc.getMap().getGridWidth() or y < 0 or y > gc.getMap().getGridHeight():
                                    continue
                                ## do the attack, targeting self
                                pPlot = gc.getMap().plot(x,y)
                                if pPlot.getNumUnits() <= 0:
                                    continue
                                for i in range(pPlot.getNumUnits()):
                                    pPotentialTarget = pPlot.getUnit(i)
                                    if gc.getTeam(pPotentialTarget.getOwner()).isAtWar(gc.getPlayer(pUnit.getOwner()).getTeam()):
                                        bEnemyNear = True
                                        break
                                    elif pPotentialTarget.getOwner() == gc.getBARBARIAN_PLAYER() and pUnit.getOwner() != gc.getBARBARIAN_PLAYER():
                                        bEnemyNear = True
                                        break
                                    elif pUnit.getOwner() == gc.getBARBARIAN_PLAYER() and pPotentialTarget.getOwner() != gc.getBARBARIAN_PLAYER():
                                        bEnemyNear = True
                                        break                                
                        if pAttack.isDefensiveEnemyNear and bEnemyNear:
                            self.doAttackAt(pUnit, pUnit.plot(), pAttack, 0)
                        elif pAttack.isDefensiveEnemyFar and not bEnemyNear:
                            self.doAttackAt(pUnit, pUnit.plot(), pAttack, 0)
                    
                   
    
    def getSidesDirection(self, iTrueDirection):
        iDirection = iTrueDirection + 2
        if iDirection > 7:
            iDirection -= 7
        return iDirection
        
    def getRearDirection(self, iTrueDirection):
        iDirection = iTrueDirection + 4
        if iDirection > 7:
            iDirection -= 7
        return iDirection
            
    def getDangerousEnemies(self, pUnit):
        lDangerousEnemies = []
        for x in range(pUnit.getX() - 10, pUnit.getX() + 10):
            for y in range(pUnit.getY() - 10, pUnit.getY() + 10):
                pPlot = gc.getMap().plot(x, y)
                if pPlot.getNumUnits() > 0:
                    for i in range(pPlot.getNumUnits()):
                        pPotentialEnemy = pPlot.getUnit(i)
                        distance = self.getDistance(pPlot, pUnit.plot())
                        iEnemyTeam = pPotentialEnemy.getTeam()
                        iEnemyPlayer = pPotentialEnemy.getOwner()
                        iUnitTeam = pUnit.getTeam()
                        pEnemyTeam = gc.getTeam(iEnemyTeam)
                        pEnemyPlayer = gc.getPlayer(iEnemyPlayer)
                        if iEnemyPlayer == pUnit.getOwner():
                            continue
                        if not (pEnemyPlayer.isBarbarian() or pEnemyTeam.isAtWar(iUnitTeam)):
                            continue ## skip this unit, it won't attack. we hope. lol
                        if self.isHasAnyAttack(pPotentialEnemy):
                            for pAttack in PushButtonUtils.lAttacks:
                                if self.getPenetrationDist(pAttack, distance) >= self.getWeakestArmorThickness(pUnit):
                                    if self.isHasAttack(pPotentialEnemy, pAttack):
                                        iEnemyDirection = -1
                                        iEnemyDirection = self.getDirectionToTarget(x, y, pUnit.plot())
                                        lDangerousEnemies.append([pPotentialEnemy, pAttack.iDamage, iEnemyDirection])
        return lDangerousEnemies                               

    def getDirectionToTarget(self, x, y, pTargetPlot):
        if x < pTargetPlot.getX():
            if y < pTargetPlot.getY():
                iEnemyDirection = 5
            elif y > pTargetPlot.getY():
                iEnemyDirection = 7
            elif pTargetPlot.getY() == y:
                iEnemyDirection = 6
        elif x > pTargetPlot.getX():
            if y < pTargetPlot.getY():
                iEnemyDirection = 3
            elif y == pTargetPlot.getY():
                iEnemyDirection = 2
            elif y > pTargetPlot.getY():
                iEnemyDirection = 1
        elif pTargetPlot.getX() == x:
            if y < pTargetPlot.getY():
                iEnemyDirection = 4
            elif y > pTargetPlot.getY():
                iEnemyDirection = 0
            else:
                return -1
        return iEnemyDirection
    
    def getWeakestArmorThickness(self, pUnit):
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            iFrontArmor = self.getFrontArmor(pUnit)
            iRearArmor = self.getRearArmor(pUnit)
            iSidesArmor = self.getSideArmor(pUnit)
            if iFrontArmor <= iRearArmor:
                if iFrontArmor < iSidesArmor:
                    return iFrontArmor
                else:
                    return iSidesArmor
            elif iRearArmor <= iFrontArmor:
                if iRearArmor < iSidesArmor:
                    return iRearArmor
                else: 
                    return iSidesArmor
        else:
            return 0
        
    def getStrongestArmorPart(self, pUnit):
        if self.isHasUnitStat(pUnit):
            pStat = self.getSpecialUnitStats(pUnit)
            sWhich = "Front"
            iFrontArmor = self.getFrontArmor(pUnit)
            iRearArmor = self.getRearArmor(pUnit)
            iSidesArmor = self.getSideArmor(pUnit)
            if iRearArmor > iFrontArmor:
                if iSidesArmor > iRearArmor:
                    sWhich = "Sides"
                elif iSidesArmor < iRearArmor:
                    sWhich = "Rear"
            elif iSidesArmor > iFrontArmor:
                sWhich = "Sides"
            return sWhich
        return "Front"
    
    def isEffectiveAttack(self, pAttacker, pAttack, pTarget):
        if not self.canAttackPlot(pAttacker, pAttack, pTarget.plot()):
            return False
        iArmorThickness = self.getArmorThickness(pAttacker, pTarget)[0]
        if iArmorThickness > self.getPenetration(pAttack, pAttacker, pTarget.plot()):
            return False
        ## AI should not attack invisible units. If this makes the human OP I might allow them to later.
        if pTarget.isInvisible(gc.getPlayer(pAttacker.getOwner()).getTeam(), False) or pTarget.getInvisibleType() != -1:
            return False
        ## AI should not attack with explosives if the attacker is too close
        if float(pAttack.iDamage / (self.getDistance(pAttacker.plot(), pTarget.plot()))**2.0) >= 1 and pAttack.bExplosive:
            return False
        return True
        
    
    
    def getEnemies(self, pUnit, iRange):
        lTargetList = []
        for x in range(pUnit.getX() - iRange, pUnit.getX() + iRange + 1):
            for y in range(pUnit.getY() - iRange, pUnit.getY() + iRange + 1):
                pPlot = gc.getMap().plot(x,y)
                if pPlot.getNumUnits() > 0:
                    for i in range(pPlot.getNumUnits()):
                        pPotentialTarget = pPlot.getUnit(i)
                        pUnitOwner = gc.getPlayer(pPotentialTarget.getOwner())
                        if gc.getTeam(pUnitOwner.getTeam()).isAtWar(gc.getPlayer(pPotentialTarget.getOwner()).getTeam()):
                            lTargetList.append(pPotentialTarget)
                        elif pPotentialTarget.getOwner() != gc.getBARBARIAN_PLAYER() and pUnit.getOwner() == gc.getBARBARIAN_PLAYER():
                            lTargetList.append(pPotentialTarget)
        return lTargetList                
    
    def isHasUnitStat(self, pUnit):
        for pStat in PushButtonUtils.lSpecialUnitStats:
            if gc.getInfoTypeForString(pStat.UnitType) == pUnit.getUnitType():
                return True
        return False
    
    def getSpecialUnitStats(self, pUnit):
        for pStat in PushButtonUtils.lSpecialUnitStats:
            if gc.getInfoTypeForString(pStat.UnitType) == pUnit.getUnitType():
                return pStat
    
## This next method was pilfered from The_J's SpawnACiv python mod. 
## I used that mod to learn how to load XML and this was a very nifty method to help with that. 
## It just cuts out the value of a line in XML and returns it. 
    def CutString(self, string):
            string = str(string)        
            string = string.strip()        
            string = string[2:-1]
            BeginPos=-1
            EndPos = -1                
            for i in xrange(len(string)):
                    if string[i]==">":
                            BeginPos=i                                
                    elif string[i]=="<":
                            EndPos=i                                
                            break
            else:
                    return "-1"
            NewString = string[BeginPos+1:EndPos]        
            return str(NewString)    


class SpecialAttack:
    def __init__(self):
        self.iRange = 0
        self.iDamage = 0
        self.PromotionType = "NONE"
        self.Description = "NONE"
        self.Effect = "NONE"
        self.Strategy = ""
        self.iMoves = 0
        self.index = -1
        self.iNumShots = 1
        self.iVolleyDropoff = 0
        self.iDmgRand = 0
        self.iDmgLimit = 100
        self.iPenetration = 0
        self.iPenDropoff = 0
        self.iPenRand = 0
        self.iAccuracy = 100
        self.iAccDropoff = 0
        self.bExplosive = False
        self.bIndirectFire = False
        self.bIgnoreDefenses = False
        self.bMissStillHits = False
        self.iMaxMissRadius = 1
        self.bSpawnUnit = False
        self.SpawnUnitType = "NONE"
        self.iSpawnUnitNum = 0
        self.bSpawnOnAttacker = False
        self.bBarbarianOwner = False
        self.bKillAttacker = False
        self.iLoseCamo = 0
        self.iAntiCamo = 0
        self.bCheckSpotting = False
        self.bFaceTarget = 0
        self.isDefensiveEnemyFar = 0
        self.isDefensiveEnemyNear = 0        
        self.lCannotAttackUnitCombats = []
        self.lSetPromotions = []
        self.lSetPromotionChances = []
        self.iRemoveAttackChance = 0
        self.iReturnFireChance = 0
        self.bCanAttackSelf = 0
        self.iOpportunityFireChance = 0
        self.SpawnUnitOnDeath = "NONE"
        self.bDeathUnitBarbarian = 0
        self.UnitClassTarget = "NONE"
        self.UnitCombatTarget = "NONE"
        self.UnitTarget = "NONE"
        
class SpecialUnitStat:
    def __init__(self):
        self.UnitType = -1
        self.iFrontArmor = 0
        self.fFrontSlope = 0.0
        self.iSidesArmor = 0
        self.fSidesSlope = 0.0
        self.iRearArmor = 0
        self.fRearSlope = 0.0
        self.fHullDownCoefficient = 1.0
        self.fHullDownSlope = 0.0
        self.index = -1
        self.iAccuracyBonus = 0
        self.bDirectionalArmor = False
        self.iRotateMoves = 0
        self.iCamouflage = -1
        self.iAntiCamo = -1
        self.iFlatSpottedChance = 0
        self.iReduceEnemyAccuracy = 0